Bug 851180 - Review Request: mingw-lcms - MinGW Color Management System
Review Request: mingw-lcms - MinGW Color Management System
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: greg.hellings
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-23 08:29 EDT by Thomas Sailer
Modified: 2016-08-14 12:25 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-01-16 14:20:43 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
greg.hellings: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Thomas Sailer 2012-08-23 08:29:03 EDT
Spec URL: http://sailer.fedorapeople.org/mingw-lcms.spec
SRPM URL: http://sailer.fedorapeople.org/mingw-lcms-1.19-1.fc17.src.rpm
Description:
MinGW Color Management System

Approved MinGW packaging guidelines are here:
http://fedoraproject.org/wiki/Packaging/MinGW
Comment 1 greg.hellings 2012-09-08 01:32:09 EDT
I'm no RPM creating professional but here's my feedback:
The %clean section is apparently no longer necessary and should be removed from your spec file.

The line "rm -rf ${RPM_BUILD_ROOT}" at the beginning of your install is no longer necessary and should be removed from your spec file.

You install line should use the macro "$mingw_make_install DESTDIR=${RPM_BUILD_ROOT}" instead of using "%mingw_make install". I'm also not sure if the INSTALL="install -p" parameter is necessary. Is it?

The lines under your %files sections which begin %defattr are no longer necessary and should be purged from your file.

The BuildRoot: line at the top of your file should be removed. The RPM building process uses sane roots already and the default values should really be used.

Below is the output of rpmlint on the results. It seems pretty clean to me.


greg@Gateway08:~/Source/fedora-mingw-staging/mingw-lcms $ rpmlint mingw-lcms-1.19-1.fc19.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
greg@Gateway08:~/Source/fedora-mingw-staging/mingw-lcms $ rpmlint noarch/mingw
mingw32-lcms-1.19-1.fc19.noarch.rpm            mingw64-lcms-1.19-1.fc19.noarch.rpm
mingw32-lcms-debuginfo-1.19-1.fc19.noarch.rpm  mingw64-lcms-debuginfo-1.19-1.fc19.noarch.rpm
mingw32-lcms-static-1.19-1.fc19.noarch.rpm     mingw64-lcms-static-1.19-1.fc19.noarch.rpm
greg@Gateway08:~/Source/fedora-mingw-staging/mingw-lcms $ rpmlint noarch/mingw32-lcms-1.19-1.fc19.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
greg@Gateway08:~/Source/fedora-mingw-staging/mingw-lcms $ rpmlint noarch/mingw32-lcms-debuginfo-1.19-1.fc19.noarch.rpm 
mingw32-lcms-debuginfo.noarch: E: debuginfo-without-sources
1 packages and 0 specfiles checked; 1 errors, 0 warnings.
greg@Gateway08:~/Source/fedora-mingw-staging/mingw-lcms $ rpmlint noarch/mingw32-lcms-static-1.19-1.fc19.noarch.rpm 
mingw32-lcms-static.noarch: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
greg@Gateway08:~/Source/fedora-mingw-staging/mingw-lcms $ rpmlint noarch/mingw64-lcms-1.19-1.fc19.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
greg@Gateway08:~/Source/fedora-mingw-staging/mingw-lcms $ rpmlint noarch/mingw64-lcms-debuginfo-1.19-1.fc19.noarch.rpm 
mingw64-lcms-debuginfo.noarch: E: debuginfo-without-sources
1 packages and 0 specfiles checked; 1 errors, 0 warnings.
greg@Gateway08:~/Source/fedora-mingw-staging/mingw-lcms $ rpmlint noarch/mingw64-lcms-static-1.19-1.fc19.noarch.rpm 
mingw64-lcms-static.noarch: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
Comment 2 greg.hellings 2012-09-08 01:36:13 EDT
I'm further curious, if there is a version 2+ out, why are you packaging this version, which is running on 3 years old now? Why is mingw-lcms2 not sufficient?
Comment 3 greg.hellings 2012-11-19 22:43:41 EST
I can now do official reviews. Pasted below is my official review for this package.

My question about why you're packaging this older version when the newer one is out still stands. Why maintain both packages in Fedora? Is this legacy release still in support? Either way, onto the review...

Items marked + are good, and those marked - have issues.

-rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
mingw32-lcms-debuginfo.noarch: E: debuginfo-without-sources
mingw32-lcms-static.noarch: W: no-documentation
mingw64-lcms-debuginfo.noarch: E: debuginfo-without-sources
mingw64-lcms-static.noarch: W: no-documentation

+The package must be named according to the Package Naming Guidelines .
+The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. 
+The package must meet the Packaging Guidelines .
+The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
+The License field in the package spec file must match the actual license.
+If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
+The spec file must be written in American English.
+The spec file for the package MUST be legible.
+The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
+The package MUST successfully compile and build into binary rpms on at least one primary architecture. (I tested x86_64 on f17)
+If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
+All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
+The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
(n/a)Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
+Packages must NOT bundle copies of system libraries.
(n/a) If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
+A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
+A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
+Permissions on files must be set properly. Executables should be set with executable permissions, for example.
+Each package must consistently use macros.
+The package must contain code, or permissable content.
+Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
+If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
+Static libraries must be in a -static package.
(n/a) Development files must be in a -devel package.
(n/a) In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
+Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
+Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
+Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
+All filenames in rpm packages must be valid UTF-8.

Additional notes:
1) Remove the 'rm -rf ${RPM_BUILD_ROOT}' as that is no longer necessary.
2) Remove the %clean section as that is no longer necessary.
3) The %defattr lines can be removed as well, they're now unnecessary.
4) Lines beginning with 'Group:' are superfluous and can be removed
5) The 'BuildRoot:' line should be removed
6) Is there a reason you are relying on mingw*-filesystem >= 68 instead of a newer version?
7) The two lines that define the globals mingw_build_win{32,64} can be safely deleted.
Comment 4 Thomas Sailer 2012-11-20 05:58:49 EST
Thanks, Greg, for your review!

(In reply to comment #2)
> I'm further curious, if there is a version 2+ out, why are you packaging
> this version, which is running on 3 years old now? Why is mingw-lcms2 not
> sufficient?

Both versions are not fully API compatible. See for example
http://littlecms2.blogspot.ch/search?updated-max=2010-02-15T17:31:00Z&max-results=12&start=12&by-date=false

This is presumably why we have both versions as native libraries as well.

I was packaging poppler for mingw, and poppler still wants lcms v1.

(In reply to comment #3)

> -rpmlint must be run on the source rpm and all binary rpms the build
> produces. The output should be posted in the review.
> mingw32-lcms-debuginfo.noarch: E: debuginfo-without-sources
> mingw64-lcms-debuginfo.noarch: E: debuginfo-without-sources

In my opinion these should be waved. mingw debuginfo packages never include the source code (see for example mingw32-libtiff-debuginfo-3.9.5-7.fc17.noarch.rpm); also, the way this package generates the debuginfo subpackage is exactly as per the fesco approved mingw packaging guidelines
https://fedoraproject.org/wiki/Packaging:MinGW?rd=Packaging/MinGW#Manpages_and_info_files

> mingw32-lcms-static.noarch: W: no-documentation
> mingw64-lcms-static.noarch: W: no-documentation

Again, these should IMO be waved, as the mingw packaging guidelines requires documentation which is just a duplicate of the documentation of the native package not to be packaged.
https://fedoraproject.org/wiki/Packaging:MinGW?rd=Packaging/MinGW#Manpages_and_info_files

> Additional notes:
> 1) Remove the 'rm -rf ${RPM_BUILD_ROOT}' as that is no longer necessary.
done

> 2) Remove the %clean section as that is no longer necessary.
done

> 3) The %defattr lines can be removed as well, they're now unnecessary.
done

> 4) Lines beginning with 'Group:' are superfluous and can be removed
I can do this if you really absolutely require this, but I find it ugly when rpm -qi reports "Group: Unspecified"; also, other mingw packages also provide a group name

> 5) The 'BuildRoot:' line should be removed
done

> 6) Is there a reason you are relying on mingw*-filesystem >= 68 instead of a
> newer version?
removed; I think this is a cut&paste artifact

> 7) The two lines that define the globals mingw_build_win{32,64} can be
> safely deleted.
done
Comment 5 Kalev Lember 2012-11-20 06:18:43 EST
(In reply to comment #4)
> > 4) Lines beginning with 'Group:' are superfluous and can be removed
> I can do this if you really absolutely require this, but I find it ugly when
> rpm -qi reports "Group: Unspecified"; also, other mingw packages also
> provide a group name

The packaging guidelines say that it's only needed for EPEL compatibility:
http://fedoraproject.org/wiki/Packaging:Guidelines#Group_tag

There's been some talk about doing a small revision of the MinGW packaging guidelines and, among other things, get rid of the group tag in the example spec file. So far it's just a draft though.

I don't think it's overly important to drop this tag, definitely not a review blocker.
Comment 6 greg.hellings 2012-11-20 11:18:01 EST
(In reply to comment #4)
> Both versions are not fully API compatible. See for example
> http://littlecms2.blogspot.ch/search?updated-max=2010-02-15T17:31:00Z&max-
> results=12&start=12&by-date=false
> 
> This is presumably why we have both versions as native libraries as well.
> 
> I was packaging poppler for mingw, and poppler still wants lcms v1.
> 

Understandable. I feel the same crunch for some software I've been trying to build.

> > -rpmlint must be run on the source rpm and all binary rpms the build
> > produces. The output should be posted in the review.
> > mingw32-lcms-debuginfo.noarch: E: debuginfo-without-sources
> > mingw64-lcms-debuginfo.noarch: E: debuginfo-without-sources
> 
> In my opinion these should be waved. mingw debuginfo packages never include
> the source code (see for example
> mingw32-libtiff-debuginfo-3.9.5-7.fc17.noarch.rpm); also, the way this
> package generates the debuginfo subpackage is exactly as per the fesco
> approved mingw packaging guidelines
> https://fedoraproject.org/wiki/Packaging:MinGW?rd=Packaging/
> MinGW#Manpages_and_info_files
> 
> > mingw32-lcms-static.noarch: W: no-documentation
> > mingw64-lcms-static.noarch: W: no-documentation
> 
> Again, these should IMO be waved, as the mingw packaging guidelines requires
> documentation which is just a duplicate of the documentation of the native
> package not to be packaged.
> https://fedoraproject.org/wiki/Packaging:MinGW?rd=Packaging/
> MinGW#Manpages_and_info_files
> 

Mea culpa. I should have marked that line as fine. Those warnings are acceptable.

> > 4) Lines beginning with 'Group:' are superfluous and can be removed
> I can do this if you really absolutely require this, but I find it ugly when
> rpm -qi reports "Group: Unspecified"; also, other mingw packages also
> provide a group name

It's not a requirement, as Kalev mentioned

> > 6) Is there a reason you are relying on mingw*-filesystem >= 68 instead of a
> > newer version?
> removed; I think this is a cut&paste artifact

This needs to be minimally versioned to >= 95. You can set it higher if there are necessary dependencies introduced in later versions, e.g. macros you use in your spec file.
Comment 7 greg.hellings 2013-01-04 10:44:41 EST
Provided you've updated the dependency to mingw*-filesystem to be versioned >= 95, this appears ready to go.
Comment 8 Thomas Sailer 2013-01-04 19:12:29 EST
Ah sorry this kinda slipped through the cracks. So this update now requires mingw*-filesystem >= 95.

http://sailer.fedorapeople.org/mingw-lcms-1.19-3.fc18.src.rpm
http://sailer.fedorapeople.org/mingw-lcms.spec
Comment 9 greg.hellings 2013-01-07 11:12:07 EST
Great. Setting review(+), in that case.
Comment 10 Thomas Sailer 2013-01-07 11:22:03 EST
Thanks Greg!

New Package SCM Request
=======================
Package Name: mingw-lcms
Short Description: MinGW Color Management System
Owners: sailer
Branches: f17 f18
InitialCC:
Comment 11 Gwyn Ciesla 2013-01-07 11:25:32 EST
Git done (by process-git-requests).
Comment 12 Fedora Update System 2013-01-07 12:08:40 EST
mingw-lcms-1.19-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/mingw-lcms-1.19-3.fc18
Comment 13 Fedora Update System 2013-01-07 12:08:51 EST
mingw-lcms-1.19-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/mingw-lcms-1.19-3.fc17
Comment 14 Fedora Update System 2013-01-07 16:22:25 EST
mingw-lcms-1.19-3.fc18 has been pushed to the Fedora 18 testing repository.
Comment 15 Fedora Update System 2013-01-16 14:20:46 EST
mingw-lcms-1.19-3.fc18 has been pushed to the Fedora 18 stable repository.
Comment 16 Fedora Update System 2013-01-18 15:36:20 EST
mingw-lcms-1.19-3.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.